#Functions from Chapter 4
#Page 40
def   max(x, y):
    if x  >  y:
        return x
    else:
        return  y

    
#Page 42, Figure 4.2
def  printName(firstName,  lastName,  reverse):
    if reverse:
        print (lastName  +  ', ' +  firstName)
    else:
        print (firstName,  lastName)


#Page 43
def   printName(firstName, lastName, reverse  =  False):
    if reverse:
        print (lastName +  ', ' +  firstName)
    else:
        print(firstName, lastName)

#Page 47, Figure 4.5
def  findRoot(x,  power,  epsilon):
    """x と epsilon > 0は整数もしくは浮動小数点数, power>=1 を整数と仮定
       y**power が x の epsilon 以内になるような浮動小数点数y を返す
       もし，そのような浮動小数点数が存在しなければ None を返す """
    if x  <  0  and  power%2  ==  0:
        return None
    low  =  min(-1.0,  x)
    high =  max(1.0,  x)
    ans  =  (high  +  low)/2.0
    while  abs(ans**power  -  x) >=  epsilon:
        if ans**power  <  x:
            low  =  ans
        else:
            high =  ans
        ans  =  (high  +  low)/2.0
    return ans

def  testFindRoot():
    epsilon  =  0.0001
    for x  in  (0.25,  -0.25,  2,  -2, 8,  -8):
        for power  in range(1, 4):
            print ('Testing  x  =  ' +  str(x) +
                   ' and  power =  ' +  str(power))
            result  =  findRoot(x,  power,  epsilon)
            if result  ==  None:
                print ('	No root')
            else:
                print (' 	', result**power,  '~=',  x)

#Page 50, Figure 4.6
def  factI(n):
    """n >0 を整数と仮定
       n! を返す"""
    result  =  1
    while  n  >  1:
        result  =  result * n
        n  -=  1
    return result

def  factR(n):
    """n >0 を整数と仮定
       n! を返す"""
    if n  ==  1:
        return  n
    else:
        return n*factR(n -  1)


#Page 52, Figure 4.7
def  fib(n):
    """n > 0 を整数と仮定
       n番目のフィボナッチ数を返す"""
    if n  ==  0  or  n  ==  1:
        return 1
    else:
        return fib(n-1)  +  fib(n-2)

def  testFib(n):
    for i in  range(n+1):
        print ('fib  of',  i, '=',  fib(i))


#Page 53, Figure 4.8
def  isPalindrome(s):
    """s を文字列と仮定
       s が回文なら，True を返し，それ以外なら False を返す
       ただし　句読点, 空白, 大文字・小文字は無視する """
    #
    def  toChars(s):
        s  =  s.lower()
        letters =  ''
        for c  in  s:
            if c  in 'abcdefghijklmnopqrstuvwxyz':
                letters =  letters +  c
        return letters
    #
    def  isPal(s):
        if len(s)  <=  1:
            return True
        else:
            return s[0] ==  s[-1]  and  isPal(s[1:-1])
    #
    return isPal(toChars(s))


#Page 54, Figure 4.9
def  isPalindrome(s):
    """s を文字列と仮定
       s が回文なら，True を返し，それ以外なら False を返す
       ただし　句読点, 空白, 大文字・小文字は無視する """
    #
    def  toChars(s):
        s  =  s.lower()
        letters =  ''
        for c  in  s:
            if c  in 'abcdefghijklmnopqrstuvwxyz':
                letters =  letters +  c
        return letters
    #
    def  isPal(s):
        print ('	isPal called  with',  s)
        if len(s)  <=  1:
            print ('	About to return True  from  base  case')
            return True
        else:
            answer =  s[0]  ==  s[-1]  and  isPal(s[1:-1])
            print ('	About to  return',  answer,  'for',  s)
            return answer
    #
    return isPal(toChars(s))

def  testIsPalindrome():
    print ('Try  dogGod')
    print (isPalindrome('dogGod'))
    print ('Try  doGood')
    print (isPalindrome('doGood'))


#Page 56, Figure 4.10
numFibCalls = 0

def  fib(x):
    """n > 0 を整数と仮定
       n 番目のフィボナッチ数を返す"""
    global  numFibCalls
    numFibCalls  +=  1
    if x  ==  0  or  x  ==  1:
        return 1
    else:
        return fib(x-1)  +  fib(x-2)

def  testFib(n):
    for i in  range(n+1):
        global  numFibCalls
        numFibCalls  =  0
        print ('fib  of',  i, '=',  fib(i))
        print ('fib  called',  numFibCalls,  'times.')


#Page 57
def   area(radius):
    return pi*(radius**2)

def   circumference(radius):    
    return 2*pi*radius

def   sphereSurface(radius):
    return 4.0*area(radius)

def   sphereVolume(radius):
    return (4.0/3.0)*pi*(radius**3)







